# coding: utf-8

"""
    Pulp 3 API

    Fetch, Upload, Organize, and Distribute Software Packages  # noqa: E501

    The version of the OpenAPI document: v3
    Contact: pulp-list@redhat.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from pulpcore.client.pulp_deb.configuration import Configuration


class DebReleaseResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'pulp_href': 'str',
        'prn': 'str',
        'pulp_created': 'datetime',
        'pulp_last_updated': 'datetime',
        'codename': 'str',
        'suite': 'str',
        'distribution': 'str',
        'version': 'str',
        'origin': 'str',
        'label': 'str',
        'description': 'str',
        'architectures': 'list[str]',
        'components': 'list[str]'
    }

    attribute_map = {
        'pulp_href': 'pulp_href',
        'prn': 'prn',
        'pulp_created': 'pulp_created',
        'pulp_last_updated': 'pulp_last_updated',
        'codename': 'codename',
        'suite': 'suite',
        'distribution': 'distribution',
        'version': 'version',
        'origin': 'origin',
        'label': 'label',
        'description': 'description',
        'architectures': 'architectures',
        'components': 'components'
    }

    def __init__(self, pulp_href=None, prn=None, pulp_created=None, pulp_last_updated=None, codename=None, suite=None, distribution=None, version=None, origin=None, label=None, description=None, architectures=None, components=None, local_vars_configuration=None):  # noqa: E501
        """DebReleaseResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._pulp_href = None
        self._prn = None
        self._pulp_created = None
        self._pulp_last_updated = None
        self._codename = None
        self._suite = None
        self._distribution = None
        self._version = None
        self._origin = None
        self._label = None
        self._description = None
        self._architectures = None
        self._components = None
        self.discriminator = None

        if pulp_href is not None:
            self.pulp_href = pulp_href
        if prn is not None:
            self.prn = prn
        if pulp_created is not None:
            self.pulp_created = pulp_created
        if pulp_last_updated is not None:
            self.pulp_last_updated = pulp_last_updated
        self.codename = codename
        self.suite = suite
        self.distribution = distribution
        self.version = version
        self.origin = origin
        self.label = label
        self.description = description
        if architectures is not None:
            self.architectures = architectures
        if components is not None:
            self.components = components

    @property
    def pulp_href(self):
        """Gets the pulp_href of this DebReleaseResponse.  # noqa: E501


        :return: The pulp_href of this DebReleaseResponse.  # noqa: E501
        :rtype: str
        """
        return self._pulp_href

    @pulp_href.setter
    def pulp_href(self, pulp_href):
        """Sets the pulp_href of this DebReleaseResponse.


        :param pulp_href: The pulp_href of this DebReleaseResponse.  # noqa: E501
        :type: str
        """

        self._pulp_href = pulp_href

    @property
    def prn(self):
        """Gets the prn of this DebReleaseResponse.  # noqa: E501

        The Pulp Resource Name (PRN).  # noqa: E501

        :return: The prn of this DebReleaseResponse.  # noqa: E501
        :rtype: str
        """
        return self._prn

    @prn.setter
    def prn(self, prn):
        """Sets the prn of this DebReleaseResponse.

        The Pulp Resource Name (PRN).  # noqa: E501

        :param prn: The prn of this DebReleaseResponse.  # noqa: E501
        :type: str
        """

        self._prn = prn

    @property
    def pulp_created(self):
        """Gets the pulp_created of this DebReleaseResponse.  # noqa: E501

        Timestamp of creation.  # noqa: E501

        :return: The pulp_created of this DebReleaseResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._pulp_created

    @pulp_created.setter
    def pulp_created(self, pulp_created):
        """Sets the pulp_created of this DebReleaseResponse.

        Timestamp of creation.  # noqa: E501

        :param pulp_created: The pulp_created of this DebReleaseResponse.  # noqa: E501
        :type: datetime
        """

        self._pulp_created = pulp_created

    @property
    def pulp_last_updated(self):
        """Gets the pulp_last_updated of this DebReleaseResponse.  # noqa: E501

        Timestamp of the last time this resource was updated. Note: for immutable resources - like content, repository versions, and publication - pulp_created and pulp_last_updated dates will be the same.  # noqa: E501

        :return: The pulp_last_updated of this DebReleaseResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._pulp_last_updated

    @pulp_last_updated.setter
    def pulp_last_updated(self, pulp_last_updated):
        """Sets the pulp_last_updated of this DebReleaseResponse.

        Timestamp of the last time this resource was updated. Note: for immutable resources - like content, repository versions, and publication - pulp_created and pulp_last_updated dates will be the same.  # noqa: E501

        :param pulp_last_updated: The pulp_last_updated of this DebReleaseResponse.  # noqa: E501
        :type: datetime
        """

        self._pulp_last_updated = pulp_last_updated

    @property
    def codename(self):
        """Gets the codename of this DebReleaseResponse.  # noqa: E501


        :return: The codename of this DebReleaseResponse.  # noqa: E501
        :rtype: str
        """
        return self._codename

    @codename.setter
    def codename(self, codename):
        """Sets the codename of this DebReleaseResponse.


        :param codename: The codename of this DebReleaseResponse.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and codename is None:  # noqa: E501
            raise ValueError("Invalid value for `codename`, must not be `None`")  # noqa: E501

        self._codename = codename

    @property
    def suite(self):
        """Gets the suite of this DebReleaseResponse.  # noqa: E501


        :return: The suite of this DebReleaseResponse.  # noqa: E501
        :rtype: str
        """
        return self._suite

    @suite.setter
    def suite(self, suite):
        """Sets the suite of this DebReleaseResponse.


        :param suite: The suite of this DebReleaseResponse.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and suite is None:  # noqa: E501
            raise ValueError("Invalid value for `suite`, must not be `None`")  # noqa: E501

        self._suite = suite

    @property
    def distribution(self):
        """Gets the distribution of this DebReleaseResponse.  # noqa: E501


        :return: The distribution of this DebReleaseResponse.  # noqa: E501
        :rtype: str
        """
        return self._distribution

    @distribution.setter
    def distribution(self, distribution):
        """Sets the distribution of this DebReleaseResponse.


        :param distribution: The distribution of this DebReleaseResponse.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and distribution is None:  # noqa: E501
            raise ValueError("Invalid value for `distribution`, must not be `None`")  # noqa: E501

        self._distribution = distribution

    @property
    def version(self):
        """Gets the version of this DebReleaseResponse.  # noqa: E501


        :return: The version of this DebReleaseResponse.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this DebReleaseResponse.


        :param version: The version of this DebReleaseResponse.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def origin(self):
        """Gets the origin of this DebReleaseResponse.  # noqa: E501


        :return: The origin of this DebReleaseResponse.  # noqa: E501
        :rtype: str
        """
        return self._origin

    @origin.setter
    def origin(self, origin):
        """Sets the origin of this DebReleaseResponse.


        :param origin: The origin of this DebReleaseResponse.  # noqa: E501
        :type: str
        """

        self._origin = origin

    @property
    def label(self):
        """Gets the label of this DebReleaseResponse.  # noqa: E501


        :return: The label of this DebReleaseResponse.  # noqa: E501
        :rtype: str
        """
        return self._label

    @label.setter
    def label(self, label):
        """Sets the label of this DebReleaseResponse.


        :param label: The label of this DebReleaseResponse.  # noqa: E501
        :type: str
        """

        self._label = label

    @property
    def description(self):
        """Gets the description of this DebReleaseResponse.  # noqa: E501


        :return: The description of this DebReleaseResponse.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this DebReleaseResponse.


        :param description: The description of this DebReleaseResponse.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def architectures(self):
        """Gets the architectures of this DebReleaseResponse.  # noqa: E501


        :return: The architectures of this DebReleaseResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._architectures

    @architectures.setter
    def architectures(self, architectures):
        """Sets the architectures of this DebReleaseResponse.


        :param architectures: The architectures of this DebReleaseResponse.  # noqa: E501
        :type: list[str]
        """

        self._architectures = architectures

    @property
    def components(self):
        """Gets the components of this DebReleaseResponse.  # noqa: E501


        :return: The components of this DebReleaseResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._components

    @components.setter
    def components(self, components):
        """Sets the components of this DebReleaseResponse.


        :param components: The components of this DebReleaseResponse.  # noqa: E501
        :type: list[str]
        """

        self._components = components

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DebReleaseResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DebReleaseResponse):
            return True

        return self.to_dict() != other.to_dict()
